#!/bin/sh

FILTER=/usr/bin/bogofilter
FILTER_DIR=/var/spool/filter
POSTFIX=/usr/sbin/sendmail
# BOGOFITLER_DIR=/var/spool/mail
EGREP=/bin/egrep

# Exit codes from <sysexits.h>
EX_TEMPFAIL=75
EX_UNAVAILABLE=69

cd $FILTER_DIR || \
        { echo $FILTER_DIR does not exist; exit $EX_TEMPFAIL; }

# Clean up when done or when aborting.
trap "rm -f inp.$$ msg.$$; exit $EX_TEMPFAIL" 0 1 2 3 15

# bogofilter returns: 0 for spam; 1 for non-spam; 2 for I/O or other errors.
rm -f inp.$$ || exit $EX_TEMPFAIL
cat > inp.$$ || exit $EX_TEMPFAIL
$FILTER -p -e < inp.$$ > msg.$$ || exit $EX_TEMPFAIL

if $EGREP -q "^X-Bogosity: Yes" < msg.$$
then
        $POSTFIX spam@kalence.org < msg.$$
        rm -f inp.$$
else
        exec $POSTFIX "$@" < msg.$$
fi

exit 0

